package com.example.remotetest;

import java.io.Serializable;
import java.lang.reflect.Field;

import com.google.gson.Gson;

import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity
{

	public static final String REMOTE_PACKAGE = "com.scurab.nightradiobuzzer.free";
	public static final String GET = "com.scurab.nightradiobuzzer.GET_ALARMS";
	public static final String SAVE = "com.scurab.nightradiobuzzer.SAVE_ALARM";
	public static final String DELETE = "com.scurab.nightradiobuzzer.DELETE_ALARM";
	public static final String RESPOND = "com.scurab.nightradiobuzzer.RESPOND";
	
	public static final int PLAYER_AUTODETECT = 0;
	public static final int PLAYER_ANDROID 	= 1;
	public static final int PLAYER_AACPLAYER = 2;
	
	Button b1;
	Button b2;
	Button b3;
	Button b4;
	Button b5;
	Button b6;
	TextView getResult;
	
	private Alarm mSavedAlarm;
	Gson gson = new Gson();
	private RespondBroadcastReceiver receiver;
	private IntentFilter intentFilter;
	
	public static final int CODE = 123;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		//register receiver to catch responds
		intentFilter = new IntentFilter(RESPOND);
		receiver = new RespondBroadcastReceiver();
		init();
	}
	
	//nothing important here
	private void init()
	{

		b1 = (Button) findViewById(R.id.button1);
		b2 = (Button) findViewById(R.id.button2);
		b3 = (Button) findViewById(R.id.button3);
		b4 = (Button) findViewById(R.id.button4);
		b5 = (Button) findViewById(R.id.button5);
		b6 = (Button) findViewById(R.id.button6);
		getResult = (TextView)findViewById(R.id.tvGetResult);

		b1.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton1Click();
			}
		});
		b2.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton2Click();
			}
		});
		b3.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton3Click();
			}
		});
		
		b4.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton4Click();
			}
		});
		b5.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton5Click();
			}
		});
		b6.setOnClickListener(new View.OnClickListener()
		{
			@Override
			public void onClick(View v)
			{
				onButton6Click();
			}
		});
	}

	public void onButton5Click()
	{
		try
		{
			Intent i = new Intent(SAVE);
			
			mSavedAlarm.Label = "My Test Alarm Updated";
			mSavedAlarm.StreamPlayer = PLAYER_AACPLAYER;
			mSavedAlarm.Time = MainUtils.convertTime12ToNumber("5:30 AM");
			mSavedAlarm.VolumeType = Alarm.VOLUMETYPE_DEFAULT;
			String json = gson.toJson(mSavedAlarm);
			
			i.putExtra("ALARM", json);
			sendBroadcast(i);
		}
		catch (Exception e)
		{
			showMessage(e);
			e.printStackTrace();
		}
	}

	public void onButton6Click()
	{
		try
		{
			Intent i = new Intent(DELETE);
	        String json = gson.toJson(mSavedAlarm);
	        i.putExtra("ALARM", json);
	        sendBroadcast(i);
		}
		catch(Exception e)
		{
			showMessage(e);
			e.printStackTrace();
		}
	}

	public void onButton4Click()
	{
		 
		try
        {
            Intent i = new Intent(SAVE);
            
            Alarm a = new Alarm();
            a.AutoDayMode = false;
            a.Days = MainUtils.convertDaysToNumber(new short[] {0,1,1,1,1,1,0,0}); //Mon - Fri
            a.HowLongPlay = 30;
            a.IsEnabled = true;
            a.Label = "My Test Alarm";
            a.NoInternetUri = "__SILENT__"; //otherwise URI to ringtone, or null or empty to take first possible from list of ringtones
            a.Stream = "http://listen.di.fm/public2/chillout.pls";
            a.StreamPlayer = PLAYER_AUTODETECT;
            a.Time = MainUtils.convertTimeToNumber("18:30");
            a.VolumeType = Alarm.VOLUMETYPE_RAISING;
            String json = gson.toJson(a);
            
            i.putExtra("ALARM", json);
            sendBroadcast(i);
            
        }
        catch (Exception e)
        {
            showMessage(e);
            e.printStackTrace();
        }
	}

	
	public void onButton3Click()
	{
		try
        {
            Intent i = new Intent(GET);
            sendBroadcast(i);
            
        }
        catch (Exception e)
        {
            showMessage(e);
            e.printStackTrace();
        }
		
	}
	
	@Override
	protected void onStart()
	{
		super.onStart();
		registerReceiver(receiver, intentFilter);
	}
	
	@Override
	protected void onStop()
	{
		super.onStop();
		unregisterReceiver(receiver);
	}

	public void onButton1Click()
	{
		try
		{
			Intent i = new Intent(Intent.ACTION_VIEW);
			i.setComponent(new ComponentName(REMOTE_PACKAGE,
					"com.scurab.nightradiobuzzer.AlarmsActivity"));
			startActivity(i);
		}
		catch (Exception e)
		{
			showMessage(e);
			e.printStackTrace();
		}
	}

	public void onButton2Click()
	{
		try
		{
			Intent i = new Intent(Intent.ACTION_VIEW);
			i.setComponent(new ComponentName(REMOTE_PACKAGE,
					"com.scurab.nightradiobuzzer.AlarmEditorActivity"));
			startActivityForResult(i, CODE);
		}
		catch (Exception e)
		{
			showMessage(e);
			e.printStackTrace();
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		super.onActivityResult(requestCode, resultCode, data);
		try
		{
			if (requestCode == CODE)
			{
				if (resultCode == RESULT_OK)
				{
					long id = data.getLongExtra("Id", -1);// just id is in
															// extras
					showMessage(String.format("Alarm id:%s saved!", id));
				}
			}
		}
		catch (Exception e)
		{
			showMessage(e);
			e.printStackTrace();
		}
	}

	public void showMessage(Exception e)
	{
		Toast.makeText(this, e.getMessage(), Toast.LENGTH_LONG).show();
	}

	public void showMessage(String msg)
	{
		Toast.makeText(this, msg, Toast.LENGTH_LONG).show();
	}

	private class RespondBroadcastReceiver extends BroadcastReceiver
	{
		@Override
		public void onReceive(Context context, Intent intent)
		{
			String action = intent.getAction(); //should be RESPOND value
			if(RESPOND.equals(action))
			{
				String req = intent.getStringExtra("REQUEST");
				if(intent.hasExtra("ERROR"))
				{
					String err = intent.getStringExtra("ERROR");
					showMessage(err);
				}
				else
				{
					if(GET.equals(req))
					{
						String alarmsJson = intent.getStringExtra("RESPOND_DATA");
						Alarm[] alarms = gson.fromJson(alarmsJson, Alarm[].class);
						showMessage(String.format("Respond: req:%s alarms:%s",req, alarms.length));
						getResult.setText(alarmsJson);
					}
					else if(SAVE.equals(req))
					{
						String alarmJson = intent.getStringExtra("RESPOND_DATA");
						mSavedAlarm = gson.fromJson(alarmJson, Alarm.class);
						showMessage(String.format("Saved alarm %s id:%s", mSavedAlarm.Label, mSavedAlarm.ID));
					}
					else if(DELETE.equals(req))
					{
						String alarmJson = intent.getStringExtra("RESPOND_DATA");
						Alarm deleted = gson.fromJson(alarmJson, Alarm.class);
						showMessage(String.format("Deleted alarm %s id:%s", deleted.Label, deleted.ID));
						mSavedAlarm = null;
					}
				}
				
				b5.setEnabled(mSavedAlarm != null);
				b6.setEnabled(mSavedAlarm != null);
			}
			else
				showMessage("Invalid RESPOND");
		}
	}
}
